From b3ef4c7f06ff367831c4a6bcc50b307b85259372 Mon Sep 17 00:00:00 2001
From: "Gao,Yan" <ygao@suse.com>
Date: Thu, 8 Dec 2022 18:04:14 +0100
Subject: [PATCH 6/6] Test: cts-scheduler: update test for preventing inactive
 instances from starting if probe is unrunnable on any nodes

---
 .../leftover-pending-monitor.dot          | 11 ++++---
 .../leftover-pending-monitor.exp          | 33 ++-----------------
 .../leftover-pending-monitor.summary  |  7 ++--
 3 files changed, 10 insertions(+), 41 deletions(-)

Index: pacemaker-1.1.19+20181105.ccd6b5b10/pengine/test10/leftover-pending-monitor.dot
===================================================================
--- pacemaker-1.1.19+20181105.ccd6b5b10.orig/pengine/test10/leftover-pending-monitor.dot
+++ pacemaker-1.1.19+20181105.ccd6b5b10/pengine/test10/leftover-pending-monitor.dot
@@ -1,13 +1,14 @@
  digraph "g" {
 "promotable-1_running_0" [ style=bold color="green" fontcolor="orange"]
 "promotable-1_start_0" -> "promotable-1_running_0" [ style = bold]
-"promotable-1_start_0" -> "stateful-1:2_start_0 node-1" [ style = bold]
+"promotable-1_start_0" -> "stateful-1:2_start_0 node-1" [ style = dashed]
 "promotable-1_start_0" [ style=bold color="green" fontcolor="orange"]
 "st-sbd_monitor_0 node-2" [ style=dashed color="red" fontcolor="black"]
-"stateful-1:2_monitor_5000 node-1" [ style=bold color="green" fontcolor="black"]
-"stateful-1:2_start_0 node-1" -> "promotable-1_running_0" [ style = bold]
-"stateful-1:2_start_0 node-1" -> "stateful-1:2_monitor_5000 node-1" [ style = bold]
-"stateful-1:2_start_0 node-1" [ style=bold color="green" fontcolor="black"]
+"stateful-1:2_monitor_5000 node-1" [ style=dashed color="red" fontcolor="black"]
+"stateful-1:2_start_0 node-1" -> "promotable-1_running_0" [ style = dashed]
+"stateful-1:2_start_0 node-1" -> "stateful-1:2_monitor_5000 node-1" [ style = dashed]
+"stateful-1:2_start_0 node-1" [ style=dashed color="red" fontcolor="black"]
 "stateful-1_monitor_0 node-2" -> "promotable-1_start_0" [ style = dashed]
+"stateful-1_monitor_0 node-2" -> "stateful-1:2_start_0 node-1" [ style = dashed]
 "stateful-1_monitor_0 node-2" [ style=dashed color="red" fontcolor="black"]
 }
Index: pacemaker-1.1.19+20181105.ccd6b5b10/pengine/test10/leftover-pending-monitor.exp
===================================================================
--- pacemaker-1.1.19+20181105.ccd6b5b10.orig/pengine/test10/leftover-pending-monitor.exp
+++ pacemaker-1.1.19+20181105.ccd6b5b10/pengine/test10/leftover-pending-monitor.exp
@@ -1,49 +1,20 @@
 <transition_graph cluster-delay="60s" stonith-timeout="60s" failed-stop-offset="INFINITY" failed-start-offset="INFINITY"  transition_id="0">
-  <synapse id="0">
+  <synapse id="0" priority="1000000">
     <action_set>
-      <rsc_op id="11" operation="monitor" operation_key="stateful-1:2_monitor_5000" on_node="node-1" on_node_uuid="1">
-        <primitive id="stateful-1" long-id="stateful-1:2" class="ocf" provider="pacemaker" type="Stateful"/>
-        <attributes CRM_meta_clone="2" CRM_meta_clone_max="3" CRM_meta_clone_node_max="1" CRM_meta_globally_unique="false" CRM_meta_interval="5000" CRM_meta_master_max="1" CRM_meta_master_node_max="1" CRM_meta_name="monitor" CRM_meta_notify="false" CRM_meta_on_node="node-1" CRM_meta_on_node_uuid="1" CRM_meta_promoted_max="1" CRM_meta_promoted_node_max="1" CRM_meta_timeout="20000" />
-      </rsc_op>
-    </action_set>
-    <inputs>
-      <trigger>
-        <rsc_op id="10" operation="start" operation_key="stateful-1:2_start_0" on_node="node-1" on_node_uuid="1"/>
-      </trigger>
-    </inputs>
-  </synapse>
-  <synapse id="1">
-    <action_set>
-      <rsc_op id="10" operation="start" operation_key="stateful-1:2_start_0" on_node="node-1" on_node_uuid="1">
-        <primitive id="stateful-1" long-id="stateful-1:2" class="ocf" provider="pacemaker" type="Stateful"/>
-        <attributes CRM_meta_clone="2" CRM_meta_clone_max="3" CRM_meta_clone_node_max="1" CRM_meta_globally_unique="false" CRM_meta_master_max="1" CRM_meta_master_node_max="1" CRM_meta_notify="false" CRM_meta_on_node="node-1" CRM_meta_on_node_uuid="1" CRM_meta_promoted_max="1" CRM_meta_promoted_node_max="1" CRM_meta_timeout="20000" />
-      </rsc_op>
-    </action_set>
-    <inputs>
-      <trigger>
-        <pseudo_event id="12" operation="start" operation_key="promotable-1_start_0"/>
-      </trigger>
-    </inputs>
-  </synapse>
-  <synapse id="2" priority="1000000">
-    <action_set>
-      <pseudo_event id="13" operation="running" operation_key="promotable-1_running_0">
-        <attributes CRM_meta_clone_max="3" CRM_meta_clone_node_max="1" CRM_meta_globally_unique="false" CRM_meta_master_max="1" CRM_meta_master_node_max="1" CRM_meta_notify="false" CRM_meta_promoted_max="1" CRM_meta_promoted_node_max="1" CRM_meta_timeout="20000" />
+      <pseudo_event id="14" operation="running" operation_key="promotable-1_running_0">
+        <attributes CRM_meta_clone_max="3" CRM_meta_clone_node_max="1" CRM_meta_globally_unique="false" CRM_meta_master_max="1" CRM_meta_master_node_max="1" CRM_meta_notify="false" CRM_meta_timeout="20000" />
       </pseudo_event>
     </action_set>
     <inputs>
       <trigger>
-        <rsc_op id="10" operation="start" operation_key="stateful-1:2_start_0" on_node="node-1" on_node_uuid="1"/>
-      </trigger>
-      <trigger>
-        <pseudo_event id="12" operation="start" operation_key="promotable-1_start_0"/>
+        <pseudo_event id="13" operation="start" operation_key="promotable-1_start_0"/>
       </trigger>
     </inputs>
   </synapse>
-  <synapse id="3">
+  <synapse id="1">
     <action_set>
-      <pseudo_event id="12" operation="start" operation_key="promotable-1_start_0">
-        <attributes CRM_meta_clone_max="3" CRM_meta_clone_node_max="1" CRM_meta_globally_unique="false" CRM_meta_master_max="1" CRM_meta_master_node_max="1" CRM_meta_notify="false" CRM_meta_promoted_max="1" CRM_meta_promoted_node_max="1" CRM_meta_timeout="20000" />
+      <pseudo_event id="13" operation="start" operation_key="promotable-1_start_0">
+        <attributes CRM_meta_clone_max="3" CRM_meta_clone_node_max="1" CRM_meta_globally_unique="false" CRM_meta_master_max="1" CRM_meta_master_node_max="1" CRM_meta_notify="false" CRM_meta_timeout="20000" />
       </pseudo_event>
     </action_set>
     <inputs/>
Index: pacemaker-1.1.19+20181105.ccd6b5b10/pengine/test10/leftover-pending-monitor.summary
===================================================================
--- pacemaker-1.1.19+20181105.ccd6b5b10.orig/pengine/test10/leftover-pending-monitor.summary
+++ pacemaker-1.1.19+20181105.ccd6b5b10/pengine/test10/leftover-pending-monitor.summary
@@ -1,34 +1,29 @@
 Using the original execution date of: 2022-12-02 17:04:52Z
+
 Current cluster status:
-  * Node List:
-    * Node node-2: pending
-    * Online: [ node-1 node-3 ]
-
-  * Full List of Resources:
-    * st-sbd	(stonith:external/sbd):	 Started node-1
-    * Clone Set: promotable-1 [stateful-1] (promotable):
-      * stateful-1	(ocf:pacemaker:Stateful):	 Stopped node-1 (Monitoring)
-      * Promoted: [ node-3 ]
-      * Stopped: [ node-1 node-2 ]
+Node node-2 (2): pending
+Online: [ node-1 node-3 ]
+
+ st-sbd	(stonith:external/sbd):	 Started node-1
+ Master/Slave Set: promotable-1 [stateful-1]
+     stateful-1	(ocf::pacemaker:Stateful):	 Stopped node-1 (Monitoring)
+     Masters: [ node-3 ]
+     Stopped: [ node-1 node-2 ]
 
 Transition Summary:
-  * Start      stateful-1:2     ( node-1 )
+  * Start      stateful-1:2     ( node-1 )  due to unrunnable stateful-1:0 monitor (blocked)
 
-Executing Cluster Transition:
+Executing cluster transition:
   * Pseudo action:   promotable-1_start_0
-  * Resource action: stateful-1      start on node-1
   * Pseudo action:   promotable-1_running_0
-  * Resource action: stateful-1      monitor=5000 on node-1
 Using the original execution date of: 2022-12-02 17:04:52Z
 
-Revised Cluster Status:
-  * Node List:
-    * Node node-2: pending
-    * Online: [ node-1 node-3 ]
-
-  * Full List of Resources:
-    * st-sbd	(stonith:external/sbd):	 Started node-1
-    * Clone Set: promotable-1 [stateful-1] (promotable):
-      * Promoted: [ node-3 ]
-      * Unpromoted: [ node-1 ]
-      * Stopped: [ node-2 ]
+Revised cluster status:
+Node node-2 (2): pending
+Online: [ node-1 node-3 ]
+
+ st-sbd	(stonith:external/sbd):	 Started node-1
+ Master/Slave Set: promotable-1 [stateful-1]
+     Masters: [ node-3 ]
+     Stopped: [ node-1 node-2 ]
+
Index: pacemaker-1.1.19+20181105.ccd6b5b10/pengine/test10/leftover-pending-monitor.scores
===================================================================
--- pacemaker-1.1.19+20181105.ccd6b5b10.orig/pengine/test10/leftover-pending-monitor.scores
+++ pacemaker-1.1.19+20181105.ccd6b5b10/pengine/test10/leftover-pending-monitor.scores
@@ -1,4 +1,5 @@
-
+Allocation scores:
+Using the original execution date of: 2022-12-02 17:04:52Z
 clone_color: promotable-1 allocation score on node-1: 0
 clone_color: promotable-1 allocation score on node-2: 0
 clone_color: promotable-1 allocation score on node-3: 0
